SET ECHO OFF NEWP 0 SPA 0 PAGES 0 FEED OFF HEAD OFF TRIMS ON LIN 1024
set serveroutput on



--DUMP THE DATA OF THE ALL SHORTED RESPECTING CONSTRAINTS
declare
type fields is varray(31) of VARCHAR(100);
type preffix is varray(31) of varchar (100);
type suffix is varray(31)  of varchar (100);

field_tchannel fields:= fields ('channel_name','source_site', 'dest_site', 'contact','BANDWIDTH','nostreams','nofiles',
               'tcp_buffer_size','nominal_throughput','channel_state','last_active','message',
               'LAST_MODIFICATION',
               'admin_dn', 'se_limit','channel_type','blocksize','http_to','tx_loglevel',
               'urlcopy_put_to','urlcopy_putdone_to','urlcopy_get_to','urlcopy_getdone_to','urlcopy_tx_to',
               'urlcopy_txmarks_to','srmcopy_direction','srmcopy_to','srmcopy_refresh_to','target_dir_check',
               'url_copy_first_txmark_to','transfer_type');

preffix_tchannel  preffix:=preffix( '''','''','''','''','','','','''','','''', 'to_timestamp_tz(''','''',
'to_timestamp_tz(''','''','''','''','''','','''','','','','','','','''','','','''','','''');
suffix_tchannel suffix:=suffix('''','''','''','''','','','','''','','''',''',''DD-MON-RR HH.MI.SSXFF AM TZH:TZM'')','''',
''',''DD-MON-RR HH.MI.SSXFF AM TZH:TZM'')','''','''','''','''','','''','','','','','','','''','','','''','','''');

query1 varchar2 (20000);
query2 varchar2 (20000);
aux varchar2 (2000);

begin

--DUMP THE DATA OF THE T_VO_ACL
for c0 in (select vo_name, principal from t_vo_acl) loop
    dbms_output.put_line('insert into t_vo_acl (vo_name, principal) values ('''||c0.vo_name||''','''||c0.principal||''');');
end loop;

--DUMP THE DATA OF THE T_CHANNEL
FOR c1 in (select channel_name from t_channel) loop
   query1:= '';
   query2 :='';
   
   -- Loops into the t_channel fields getting the value of each field and constructing the insert query. 
   
   for i in 1 .. 31 loop

      execute immediate ('select '|| field_tchannel(i) ||' from t_channel where channel_name = '''|| c1.channel_name ||'''') into aux;
      if aux is not NULL then
        if  i = 1  then
            query1:= query1 || field_tchannel(i);
            query2:= query2 || preffix_tchannel(i)||''||aux||''||suffix_tchannel(i);
        else
            query1:= query1 || ','|| field_tchannel(i);
            query2:= query2 || ',' ||preffix_tchannel(i)||''||aux||''||suffix_tchannel(i);
        end if;
      end if;
   end loop;
   dbms_output.put_line('insert into t_channel (' ||query1 || ') values (' ||query2|| ');');
 
   end loop;
   
--DUMP THE DATA OF THE T_CHANNEL_ACL
for c2 in (select channel_name, principal from t_channel_acl) loop
    dbms_output.put_line('insert into t_channel_acl (channel_name, principal) values ('''||c2.channel_name||''','''||c2.principal||''');'); 
end loop;   

-- DUMP THE DATA FROM T_SITE_GROUP
for c3 in (select group_name, site_name, priority from t_site_group ) loop
    if c3.priority is null then 
        dbms_output.put_line('insert into t_site_group (group_name, site_name) values ('''||c3.group_name||''','''||c3.site_name||''');');
    else
        dbms_output.put_line('insert into t_site_group (group_name, site_name, priority) values ('''||c3.group_name||''','''||c3.site_name||''', '||c3.priority||');'); 
    end if;
end loop;

end;
/

--DUMP DATA FROM T_CHANNEL_VO_SHARE

declare
type fields is varray(5) of VARCHAR(100);
type preffix is varray(5) of varchar (5);

field_cVoShare fields:= fields('CHANNEL_NAME','VO_NAME','CHANNEL_SHARE','CHANNEL_LIMIT','CHANNEL_VOSTATE');
preffix_cVoShare preffix:= preffix('''','''','','','''');

query1 varchar2 (20000);
query2 varchar2 (20000);
aux varchar2 (2000);

begin
FOR c4 in (select CHANNEL_NAME,VO_NAME,CHANNEL_SHARE,CHANNEL_LIMIT,CHANNEL_VOSTATE from t_channel_vo_share) loop
   query1:= 'Insert into T_CHANNEL_VO_SHARE (CHANNEL_NAME,VO_NAME';
   query2 :=') values ('''||c4.CHANNEL_NAME||''','''||c4.VO_NAME||'''';
   
   -- Loops into the t_channel fields getting the value of each field and constructing the insert query. 
   
   for i in 3 .. 5 loop

      execute immediate ('select '|| field_cVoShare(i) ||' from t_channel_vo_share where channel_name = '''|| c4.channel_name ||''' and vo_name = '''||c4.vo_name||'''') into aux;
      if aux is not NULL then
          query1:= query1 || ','|| field_cVoShare(i);
          query2:= query2 || ',' ||preffix_cVoShare(i)||''||aux||''||preffix_cVoShare(i);
      end if;
   end loop;
   dbms_output.put_line(query1 ||query2|| ');');
end loop;
end;
/
exit;

